package models

import "time"

type (
	UserTeam string
	UserRole string
)

const (
	// UserTeam
	UserTeamBlue = "blue"
	UserTeamRed  = "red"
	UserTeamNone = "none"
	//UserRole
	UserRoleMime    = "mime"
	UserRoleGuesser = "guesser"
	UserRoleNone    = "none"
)

func StrToUserTeam(s string) UserTeam {
	switch s {
	case "blue":
		return UserTeamBlue
	case "red":
		return UserTeamRed
	default:
		return UserTeamNone
	}
}

func StrToUserRole(s string) UserRole {
	switch s {
	case "mime":
		return UserRoleMime
	case "guesser":
		return UserRoleGuesser
	default:
		return UserRoleNone
	}
}

type UserState struct {
	Username string
	Room     Room
	Team     UserTeam
	Role     UserRole
}

func MakeTestState() *UserState {
	cards := []WordCard{
		{Word: "hamster", Color: "blue"},
		{Word: "child", Color: "red"},
		{Word: "wheel", Color: "white"},
		{Word: "condition", Color: "black"},
		{Word: "test", Color: "white"},
		{Word: "ball", Color: "blue"},
		{Word: "violin", Color: "red"},
		{Word: "rat", Color: "white"},
		{Word: "perplexity", Color: "blue"},
		{Word: "notion", Color: "red"},
	}
	room := Room{
		ID:          "test-id",
		CreatedAt:   time.Now(),
		CreatorName: "test-name",
		Cards:       cards,
	}
	return &UserState{
		Username: "test-name",
		Team:     UserTeamNone,
		Role:     UserRoleNone,
		Room:     room,
	}
}
